Package: truncdist
Version: 1.0-2
Date: 2016-08-29
Author: Frederick Novomestky <fn334@nyu.edu>,
        Saralees Nadarajah <saralees.nadarajah@manchester.ac.uk>
Maintainer: Frederick Novomestky <fnovomes@poly.edu>
Depends: R (>= 2.0.1), stats4,evd
Description: A collection of tools to evaluate probability density
        functions, cumulative distribution functions, quantile functions
        and random numbers for truncated random variables.  These functions are
        provided to also compute the expected value and variance. Nadarajah
        and Kotz (2006) developed most of the functions. QQ plots can be produced.
        All the probability functions in the stats, stats4 and evd
        packages are automatically available for truncation..
Title: Truncated Random Variables
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2016-08-29 20:20:23 UTC; fred
Repository: CRAN
Date/Publication: 2016-08-30 01:27:43

qtrunc <- function( p, spec, a = -Inf, b = Inf, ... )
{
###
### This function evaluates the inverse of the truncated distribution function
### or quantile function for the given vector of probabilities and
### the specified distribution
###
### Arguments
### p = a numeric vector of probabilities
### spec = a character value for the name of the distribution (e.g., "norm")
### ... = other arguments passed to the corresponding density function
###
    if ( a >= b )
        stop( "argument a is greater than or equal to b" )
    tt <- p
    G   <- get( paste( "p", spec, sep="" ), mode = "function" )
    Gin <- get( paste( "q", spec, sep="" ), mode = "function" )
    G.a <- G( a, ... )
    G.b <- G( b, ... )
    if ( G.a == G.b ) {
        stop( "Trunction interval is not inside the domain of the quantile function" )
    }    
    result <- pmin( pmax( a, Gin( G( a, ... ) + 
              p * ( G( b, ... ) - G( a, ... )), ... ) ), b )
    return( result )
}    
    

ptrunc <- function( q, spec, a = -Inf, b = Inf, ... )
{
###
### this function computes the distribution function defined by the spec argument
### for the vector of quantile values in x.  The random variable is truncated
### to be in the interval ( a, b )
###
### Arguments
### q = a numeric vector of quantiles
### spec = a character value for the name of the distribution (e.g., "norm")
### ... = other arguments passed to the corresponding density function
###
    if ( a >= b )
        stop( "argument a is greater than or equal to b" )
    tt <- q
    aa <- rep( a, length( q ) )
    bb <- rep( b, length( q ) )
    G <- get( paste( "p", spec, sep="" ), mode="function" )
    tt <- G( apply( cbind( apply( cbind( q, bb ), 1, min ), aa ), 1, max ), ... )
    tt <- tt - G ( aa, ... )
    G.a <- G( aa, ... )
    G.b <- G( bb, ... )
    if ( any( G.a == G.b ) ) {
        stop( "Trunction interval is not inside the domain of the distribution function" )
    }    
    result <- tt / ( G( bb, ... ) - G ( aa, ... ) )
    return( result )
}

qqtrunc <- function( x, spec, a=-Inf, b=Inf, title="Truncated Distribution Q-Q Plot", 
    xlabel="Theoretical Quantiles", ylabel="Sample Quantiles", ... )
{
###
### This function produces a q-q plot of sample quantiles against theoretical
### quantiles for a truncated random variable
###
### Arguments
### x   = a numeric vector of sample values
### min = a numeric value for the lower bound of the uniform distribution
### max = a numeric value for the upper bound of the uniform distribution
###
    plot( qtrunc(ppoints(x), spec, a=a, b=b, ...), 
        sort(x), main=title,
        xlab=xlabel, ylab=ylabel ) 
    abline( 0,1 )
    return( invisible( 0 ) )
}

rtrunc <- function( n, spec, a = -Inf, b = Inf, ... )
{
###
### This function generates n random numbers that are drawn from
### the specified truncated distribution.
###
### Arguments
### n = a positive integer for the number of random numbers generated
### spec = a character value for the name of the distribution (e.g., "norm")
### ... = other arguments passed to the corresponding density function
###
    if ( a >= b )
        stop( "argument a is greater than or equal to b" )
    u <- runif( n, min = 0, max = 1 )
    x <- qtrunc( u, spec, a = a, b = b, ... )
    return( x )
}

dtrunc <- function( x, spec, a = -Inf, b= Inf, ... )
{
###
### this function computes the density function defined by the spec argument
### for the vector of quantile values in x.  The random variable is truncated
### to be in the interval ( a, b )
###
### Arguments
### x = a numeric vector of quantiles
### spec = a character value for the name of the distribution (e.g., "norm")
### ... = other arguments passed to the corresponding density function
###
    if ( a >= b ) 
        stop( "argument a is greater than or equal to b" )
    tt <- rep( 0, length( x ) )
    g <- get( paste( "d", spec, sep="" ), mode="function" )
    G <- get( paste( "p", spec, sep="" ), mode="function" )
    G.a <- G( a, ... )
    G.b <- G( b, ... )
    if ( G.a == G.b ) {
        stop( "Trunction interval is not inside the domain of the density function" )
    }    
    tt[x >= a & x <= b] <- g( x[x >= a & x <= b], ...) / ( G( b, ... ) - G( a, ... ) )
    return( tt )
}

extrunc <- function( spec, a = -Inf, b = Inf, ... )
{
###
### This function computes the expected value of a truncated random variable
### with the given specification over the truncated domain using
### numerical integration
###
### Arguments
### spec = a character value to specify the distribution
### a = a numeric value for the lower bound of the truncation interval
### b = a numeric value for the upper bound of the truncation interval
### ... = one or more arguments used by the density function
###
    if ( a >= b )
        stop( "argument a is greater than or equal to b" )
    f <- function( x ) { x * dtrunc( x, spec, a = a, b = b, ... ) }
    return( integrate( f, lower = a, upper = b )$value )
}

\name{rtrunc}
\alias{rtrunc}
\title{ Generate truncated random deviates }
\description{
  This function generates n random deviates that are drawn
  from the specified truncated distribution.
}
\usage{
rtrunc(n, spec, a = -Inf, b = Inf, ...)
}
\arguments{
  \item{n}{a positive integer for the number of random deviates generated }
  \item{spec}{ a character value that specifies the underlying probability distribution }
  \item{a}{ a numeric value for the lower bound of the random variable }
  \item{b}{ a numeric value for the upper bound of the random variable }
  \item{\dots}{ other arguments are are passed to the corresponding quantile function }
}
\value{
  A vector with one or more random deviates.
}
\references{
Nadarajah, S. and S. Kotz, 2006. \code{R} Programs for Computing
Truncated Distributions, \emph{Journal of Statistical Software},
16, August 2006, \url{http://www.jstatsoft.org/v16/c02}
}
\author{
Frederick Novomestky \email{fn334@nyu.edu}

Saralees Nadarajah \email{saralees.nadarajah@manchester.ac.uk}
}
\seealso{
  \code{\link{qtrunc}}
}
\examples{
x <- rtrunc( 500, spec="norm", a=1, b=2 )
}
\keyword{ math }

\name{qtrunc}
\alias{qtrunc}
\title{ Quantitle Function for Truncated Random Variable }
\description{
  This function evaluates the inverse of the cumulative distribution funciton
  for a truncated random variable or so the so called quantile function for
  a given vector of probabilities and the specified distribution.
}
\usage{
qtrunc(p, spec, a = -Inf, b = Inf, ...)
}
\arguments{
  \item{p}{ A vector of probabilities }
  \item{spec}{ a character value that specifies the underlying probability distribution }
  \item{a}{ a numeric value for the lower bound of the random variable }
  \item{b}{ a numeric value for the upper bound of the random variable }
  \item{\dots}{ other arguments are are passed to the corresponding quantile  and distribution function }
}
\value{
  A vector of quantile values in the range of the truncated random variable.
}
\references{
Nadarajah, S. and S. Kotz, 2006. \code{R} Programs for Computing
Truncated Distributions, \emph{Journal of Statistical Software},
16, August 2006, \url{http://www.jstatsoft.org/v16/c02}
}
\author{
Frederick Novomestky \email{fn334@nyu.edu}

Saralees Nadarajah \email{saralees.nadarajah@manchester.ac.uk}
}
\examples{
p <- seq( .1, .9, .01 )
q <- qtrunc( p, spec="norm", a=1, b=2 )
}
\keyword{ math }

\name{dtrunc}
\alias{dtrunc}
\title{ Probability density function of truncated random variables
}
\description{
  This function computes values for the probability density function
  of a truncated random variable.
}
\usage{
dtrunc(x, spec, a = -Inf, b = Inf, ...)
}
\arguments{
  \item{x}{ A numeric vector of quantile values }
  \item{spec}{ a character value that specifies the underlying probability distribution }
  \item{a}{ a numeric value for the lower bound of the random variable }
  \item{b}{ a numeric value for the upper bound of the random variable }
  \item{\dots}{ other arguments are are passed to the corresponding quantile function }
}
\details{
  The \code{R} function is used to access the required probability density and cumulative
  distribution functions of the underlying unrestricted random variable.
}
\value{
  A vector of density function values.
}
\references{
Nadarajah, S. and S. Kotz, 2006. \code{R} Programs for Computing
Truncated Distributions, \emph{Journal of Statistical Software},
16, August 2006, \url{http://www.jstatsoft.org/v16/c02}
}
\author{
Frederick Novomestky \email{fnovomes@poly.edu}

Saralees Nadarajah \email{saralees.nadarajah@manchester.ac.uk}
}
\examples{
x <- seq( 0, 3, .1 )
pdf <- dtrunc( x, spec="norm", a=1, b=2 )
}
\keyword{ math }

\name{extrunc}
\alias{extrunc}
\title{ Expected value of a truncated random variable }
\description{
  This function computes the expected value of a truncated random variable
  using numerical integration.
}
\usage{
extrunc(spec, a = -Inf, b = Inf, ...)
}
\arguments{
  \item{spec}{ a character value that specifies the underlying probability distribution }
  \item{a}{ a numeric value for the lower bound of the random variable }
  \item{b}{ a numeric value for the upper bound of the random variable }
  \item{\dots}{ other arguments are are passed to the corresponding quantile function }
}
\details{
  Numerical integration of the truncated density function is performed to compute
  the expected value.
}  
\value{
  A numerical value for the expectation.
}
\references{
Nadarajah, S. and S. Kotz, 2006. \code{R} Programs for Computing
Truncated Distributions, \emph{Journal of Statistical Software},
16, August 2006, \url{http://www.jstatsoft.org/v16/c02}
}
\author{
Frederick Novomestky \email{fn334@nyu.edu}

Saralees Nadarajah \email{saralees.nadarajah@manchester.ac.uk}
}
\seealso{
  \code{\link{dtrunc}}
}
\examples{
mu <- extrunc( spec="norm",a=1, b=2 )
}
\keyword{ math }
